//+------------------------------------------------------------------+
//|                                        Moving_Averages_xrust.mq4 |
//|                      Copyright  2008, Xrust.                    |
//|                                        http://www.xrust.ucoz.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Xrust"
#property link      "http://www.xrust.ucoz.net"
#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Indigo
#property indicator_color2 Blue
#property indicator_color3 Green
#property indicator_color4 Magenta
#property indicator_color5 Red
#property indicator_color6 Orange
#property indicator_color7 Blue
#property indicator_color8 Black
//---- buffers
double Ma1[];
double Ma2[];
double Ma3[];
double Ma4[];
double Ma5[];
double Ma6[];
double strart[];
double stop[];
//--------------------------------------------
extern int period = 8;
extern int metod  = 3;
extern int prise  = 0;
extern string buy   = "";
extern string close = "";
extern bool ma1viz=true;
extern bool ma2viz=true;
extern bool ma3viz=true;
extern bool ma4viz=true;
extern bool ma5viz=true;
extern bool ma6viz=true;
//--------------------------------------------
int ma1,ma2,ma3,ma4,ma5,ma6;
static int prevtime = 0 ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   if(ma1viz){int a=0;}else{a=12;}
   if(ma2viz){int b=0;}else{b=12;}
   if(ma3viz){int c=0;}else{c=12;}
   if(ma4viz){int d=0;}else{d=12;}
   if(ma5viz){int e=0;}else{e=12;}
   if(ma6viz){int f=0;}else{f=12;}
   SetIndexStyle(0,a);
   SetIndexBuffer(0,Ma1);
   SetIndexStyle(1,b);
   SetIndexBuffer(1,Ma2);
   SetIndexStyle(2,c);
   SetIndexBuffer(2,Ma3);
   SetIndexStyle(3,d);
   SetIndexBuffer(3,Ma4);
   SetIndexStyle(4,e);
   SetIndexBuffer(4,Ma5);
   SetIndexStyle(5,f);
   SetIndexBuffer(5,Ma6);
   SetIndexStyle(6,DRAW_ARROW,233,2,Blue);
   SetIndexBuffer(6,strart);
   SetIndexStyle(7,DRAW_ARROW,251,2,Black);
   SetIndexBuffer(7,stop);   
//----
int per= Period();
  if(per==1){ma1=period;
            ma2=period*5;
            ma3=period*15;
            ma4=period*30;
            ma5=period*60;
            ma6=period*240;
            }
  if(per==5){ma1=period;
            ma2=period*3;
            ma3=period*6;
            ma4=period*12;
            ma5=period*48;
            ma6=period*288;
            }
  if(per==15){ma1=period;
            ma2=period*2;
            ma3=period*4;
            ma4=period*16;
            ma5=period*96;
            ma6=period*672;
            }
  if(per==30){ma1=period;
            ma2=period*2;
            ma3=period*8;
            ma4=period*48;
            ma5=period*336;
            ma6=0;
            }
  if(per==60){ma1=period;
            ma2=period*4;
            ma3=period*24;
            ma4=period*168;
            ma5=period*336;
            ma6=0;
            } 
  if(per==240){ma1=period;
            ma2=period*3;
            ma3=period*21;
            ma4=period*84;
            ma5=period*252;
            ma6=0;
            }
  if(per>240){ma1=period;
            ma2=period*3;
            ma3=period*8;
            ma4=period*21;
            ma5=period*55;
            ma6=period*144;
            }                                               
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
//----
   if(counted_bars>0)
        counted_bars--;   
   for (int i=1;i<Bars;i++)//     
     {
     if(ma1!=0){Ma1[i] =iMA(NULL,0,ma1,0,metod,prise,i);}
     if(ma2!=0){Ma2[i] =iMA(NULL,0,ma2,0,metod,prise,i);}
     if(ma3!=0){Ma3[i]=iMA(NULL,0,ma3,0,metod,prise,i);} 
     if(ma4!=0){Ma4[i]=iMA(NULL,0,ma4,0,metod,prise,i);} 
     if(ma5!=0){Ma5[i]=iMA(NULL,0,ma5,0,metod,prise,i);}
     if(ma6!=0){Ma6[i]=iMA(NULL,0,ma6,0,metod,prise,i);}  
     //ExtMapBuffer7[i]=iMA(NULL,0,ma7,0,metod,prise,i); 
     } 
//----
   return(0);
  }
//+------------------------------------------------------------------+